<template>
  <div v-loading="loading">
    <div
      v-if="isHasGroupTitle"
      class="top-game-title border-l-[10px] border-b-2 w-full p-[5px] my-[10px] text-white"
    >
      {{ groupTitle }}
    </div>
    <div
      :class="`blog-game text-xs grid gap-${gap} mb-1 grid-cols-${grid} justify-items-center`"
    >
      <div v-for="(game, index) in gameReadyToRender" :key="index" class="w-[180px] game-card-container btn-favorite-wrapper" 
      @mouseenter="handleMouseEnter($event)"
      @mouseleave="handleMouseLeave($event)"
      >
        <template v-if="authenticated">
          <a
            v-if="!game.IsMaintain"
            href="#"
            class="cursor-pointer"
            @click.prevent="handlePlayGame(game, 850, 850, 'GameLobby')"
          >
            <div
              class="h-[180px] relative aspect-[1/1] overflow-hidden game-card-image"
              :class="{ group: !isMobile }"
            >
              <template v-if="isIndependent">
                <SharedButtonFavorite
                  class="absolute top-1 right-1"
                  :game="game"
                  :index="index"
                />
                <SharedGameTags
                  :is-hot="game.IsHotGame"
                  :is-new="game.IsNewGame"
                  class="top-1 left-1 absolute"
                  width="33.64px"
                />
              </template>
              <template v-else>
                <SharedButtonFavorite
                  class="absolute"
                  :class="[isMobile ? 'top-1 right-1' : '']"
                  :game="game"
                  :index="index"
                />
                <!-- <IconFavorite
                  :ForMobile="isMobile"
                  :toggle-dialog="isMobile"
                  :gameData="game"
                  :checkIsFavourite="checkIsFavourite"
                  :redirectToLogin="redirectToLogin"
                  :setAndUnsetGameToFavourite="setAndUnsetGameToFavourite"
                /> -->
                <span class="icon-status" :class="checkStatus(game)"></span>
              </template>
              <img
                v-lazy="isImageVersionExist(game.GameIconUrl)"
                :alt="game.GameName"
                class="object-cover object-top w-full h-full rounded-2xl"
              />
              <div class="play__now__overlay group-hover:opacity-100 pb-4 items-end">
                <span class="play__now__content_for_animate bg-primary">{{ $t("play_now") }}</span>
              </div>
            </div>
            <el-tooltip v-if="showGameName"
              :content="game.GameName"
              effect="light"
              popper-class="game-name"
              raw-content
            >
              <div class="leading-[35px] text-[var(--text2)] text-center truncate game-name-label">{{ game.GameName }}</div>
            </el-tooltip>
          </a>
          <div v-else>
            <div class="h-[180px] relative aspect-[1/1] overflow-hidden game-card-image" :class="{'group' : !isMobile}">
              <SharedButtonFavorite
                class="absolute"
                :class="[isMobile ? 'top-1 right-1' : 'top-2 right-2']"
                :game="game"
                :index="index"
              />
              <!-- <IconFavorite
                :ForMobile="isMobile"
                :toggle-dialog="isMobile"
                :gameData="game"
                :checkIsFavourite="checkIsFavourite"
                :redirectToLogin="redirectToLogin"
                :setAndUnsetGameToFavourite="setAndUnsetGameToFavourite"/> -->
              <span class="icon-status" :class="checkStatus(game)"></span>
              <img
                v-lazy="isImageVersionExist(game.GameIconUrl)"
                :alt="game.GameName"
                class="object-cover object-top w-full h-full rounded-2xl"
              />
              <div class="play__now__overlay group-hover:opacity-100 pb-4 items-end">
                <span class="play__now__content_for_animate bg-primary">{{ $t("play_now") }}</span>
              </div>
            </div>
            <el-tooltip v-if="showGameName"
              :content="game.GameName"
              effect="light"
              popper-class="game-name"
              raw-content
            >
              <div class="leading-[35px] text-[var(--text2)] text-center truncate game-name-label">{{ game.GameName }}</div>
            </el-tooltip>
          </div>
        </template>
        <div v-else @click="isMobile ? toggleLoginRegisterDialog() : redirectToLogin()" class="cursor-pointer">
          <div class="h-[180px] relative aspect-[1/1] overflow-hidden game-card-image" :class="{'group' : !isMobile}">
            <template v-if="isIndependent">
              <SharedButtonFavorite
                class="absolute top-1 right-1"
                :game="game"
                :index="index"
              />
              <SharedGameTags
                :is-hot="game.IsHotGame"
                :is-new="game.IsNewGame"
                class="top-1 left-1 absolute"
                width="33.64px"
              />
            </template>
            <template v-else>
              <SharedButtonFavorite
                class="absolute"
                :class="[isMobile ? 'top-1 right-1' : 'top-2 right-2']"
                :game="game"
                :index="index"
              />
              <!-- <IconFavorite
                :ForMobile="isMobile"
                :toggle-dialog="isMobile"
                :gameData="game"
                :checkIsFavourite="checkIsFavourite"
                :redirectToLogin="redirectToLogin"
                :setAndUnsetGameToFavourite="setAndUnsetGameToFavourite"/> -->
              <span class="icon-status" :class="checkStatus(game)"></span>
            </template>
            <img
              v-lazy="isImageVersionExist(game.GameIconUrl)"
              :alt="game.GameName"
              class="object-cover object-top w-full h-full rounded-2xl"
            />
            <div class="play__now__overlay group-hover:opacity-100 pb-4 items-end">
              <span class="play__now__content_for_animate bg-primary">{{ $t("play_now") }}</span>
            </div>
          </div>
          <el-tooltip v-if="showGameName"
            :content="game.GameName"
            effect="light"
            popper-class="game-name"
            raw-content
          >
            <div class="leading-[35px] text-[var(--text2)] text-center truncate game-name-label">{{ game.GameName }}</div>
          </el-tooltip>
        </div>
      </div>
      <div v-if="isHasLoadMore" ref="intersectionObserverRef"></div>
      <ElBacktop :right="30" :bottom="30" class="totop-button">
        <div class="w-[35px] h-[35px] flex items-center justify-center">
          <font-awesome-icon icon="arrow-up" class="text-black" />
        </div>
      </ElBacktop>
    </div>
    <div
      v-show="games.length === 0 && !loading"
      class="col-span-3 my-[60px] p-2 overflow-hidden text-4xl text-center truncate no-data text-ellipsis"
      >
      <span v-if="activeTab !== 'favorite'">{{ $t("no_games_please_come_back_later") }}</span>
      <span v-else>{{ $t('No game has been added to favorite.') }}</span>
    </div>
  </div>
</template>

<script lang="ts">
import _ from 'lodash';
import {
  computed,
  defineComponent,
  PropType,
  ref,
  watch,
  onMounted,
  nextTick,
} from "vue";
import { ElBacktop } from "element-plus";
import { IGameBsi } from "@/models/bsiGameList";
import { handleGameEntryOpenWindow } from "@/composables/useTheme";
import { store } from "@/store";
export default defineComponent({
  name: "GameEntry",
  components: {
    ElBacktop,
  },
  props: {
    loading: {
      type: Boolean,
      default: false,
    },
    games: {
      type: Array as PropType<IGameBsi[]>,
      default: () => [],
    },
    isHasGroupTitle: {
      type: Boolean,
      default: false,
    },
    groupTitle: {
      type: String,
      default: "",
    },
    classGameName: {
      type: String,
      default: "",
    },
    handlePlayGame: {
      type: Function,
      required: true,
      default: handleGameEntryOpenWindow,
    },
    grid: {
      type: Number,
      default: 6,
    },
    gap: {
      type: Number,
      default: 2,
    },
    showStaus: {
      type: Boolean,
      default: false,
    },
    showGameName: {
      type: Boolean,
      default: true,
    },
    isIndependent: {
      type: Boolean,
      default: false,
    },
    isHasLoadMore: {
      type: Boolean,
      default: true,
    },
  },
  setup(props) {
    const intersectionObserverRef = ref();
    const {
      activeTab,
    } = useGameEntryComponent();
    const {
      setAndUnsetGameToFavourite,
      checkIsFavourite,
      redirectToLogin,
    } = useAddToFavorite();
    const authenticated = computed(() => store.state.auth);
    const checkStatus = (game: IGameBsi): string => {
      let status = "disabled";
      if (props.showStaus) {
        if (game.IsNewGame && !game.IsHotGame) status = "new";
        if (game.IsHotGame) status = "hot";
      }
      return status;
    };
    const gameReadyToRender = ref<Array<IGameBsi> | undefined>([]);
    const index = ref(0);
    const gameRender = computed(() => {
      const chunkSize = 24;
      const games = [];
      if (props.games !== undefined) {
        for (let i = 0; i < props.games.length; i += chunkSize) {
          const chunk: Array<IGameBsi> | undefined = props.games.slice(
            i,
            i + chunkSize
          );
          games.push(chunk);
        }
      }
      return games;
    });
    const gameRenderer = () => {
      gameRender.value[index.value].forEach((item) => {
        gameReadyToRender.value?.push(item);
      });
    };
    if (props.games.length) {
      gameRenderer();
    }
    watch(gameRender, () => {
      gameReadyToRender.value = [];
      index.value = 0;
      if (gameRender.value.length) {
        gameRenderer();
      }
    });
    let timeout;
    const gameLoading = () => {
      clearTimeout(timeout);
      timeout = setTimeout(() => {
        index.value += 1;
        if (index.value < gameRender.value.length) {
          gameRenderer();
        }
      }, 100);
    };
    const isImageVersionExist = (imageURL: string): string => {
      if (_.includes(imageURL, '?v=')) {
        return imageURL;
      }
      return `${imageURL}?v=${store.state.imageVersion}`;
    };
    const isMobile = !useIsDesktop();
    const { toggleLoginRegisterDialog } = commonHelper;
    const mouseHasLeft = ref(false);
    const handleMouseEnter = (event: MouseEvent) => {
      mouseHasLeft.value = false;
      const target = event.currentTarget as HTMLElement;
      const inactiveId = target.querySelector(
        "#inactive-favourite"
      ) as HTMLElement;
      if (inactiveId) {
        inactiveId.style.animation = "fadeInFromTop 0.5s ease-in-out forwards";
      }
    };
    const handleMouseLeave = (event: MouseEvent) => {
      mouseHasLeft.value = true;
      const target = event.currentTarget as HTMLElement;
      const activeId = target.querySelector("#active-favourite") as HTMLElement;
      const inactiveId = target.querySelector(
        "#inactive-favourite"
      ) as HTMLElement;

      if (activeId && inactiveId) {
        const activeAnimation = window.getComputedStyle(activeId).animationName;

        if (activeAnimation === "none") {
          inactiveId.style.animation = "fadeOutToTop 0.2s ease-in-out forwards";
        } else {
          // Delay the execution of the mouseleave event handler
          activeId.addEventListener(
            "animationend",
            () => {
              // If the mouse has left during the active-favourite animation, start the inactive-favourite animation
              if (mouseHasLeft.value) {
                inactiveId.style.animation =
                  "fadeOutToTop 0.2s ease-in-out forwards";
              }
            },
            { once: true }
          );
        }
      }
    };
    onMounted(() => {
      nextTick(() => {
        const el = intersectionObserverRef.value as HTMLElement;
        const observer = new IntersectionObserver((entries) => {
          if (entries[0].isIntersecting) {
            gameLoading();
          }
        });
        observer.observe(el);
      });
    });
    return {
      intersectionObserverRef,
      authenticated,
      checkStatus,
      gameLoading,
      gameReadyToRender,
      isImageVersionExist,
      setAndUnsetGameToFavourite,
      checkIsFavourite,
      redirectToLogin,
      activeTab,
      isMobile,
      toggleLoginRegisterDialog,
      handleMouseEnter,
      handleMouseLeave,
    };
  },
});
</script>
<style scoped lang="scss">
[layout="playful"][data-device="mobile"] {
  .el-backtop {
    display: none;
  }
}
.blog-game {
  .icon-status:not(.disabled) {
    position: absolute;
    width: 60px;
    height: 28px;
    border-top-left-radius: 16px;
    border-bottom-right-radius: 16px;
    top: 0px;
    left: 0px;
    color: var(--text5);
    text-align: center;
    font-family: "Roboto";
    font-style: normal;
    font-weight: 700;
    font-size: 16px;
    letter-spacing: 0.02em;
    z-index: 20;
    &.new {
      background-color: #2A71DC;
      &::after {
        content: "New";
        position: absolute;
        top: 6px;
        left: 15px;
      }
    }
    &.hot {
      background-color: #FF264D;
      &::after {
        content: "Hot";
        position: absolute;
        top: 6px;
        left: 15px;
      }
    }
  }
}
.play__now__overlay {
  @apply opacity-0 group-hover:opacity-100 transition-opacity duration-[250ms] absolute top-0 z-10 w-full h-full grid rounded-2xl justify-center bg-[#05071ecc];
}
.play__now__content_for_animate {
  @apply flex justify-center items-center text-sm font-bold text-white rounded-md h-8 w-fit px-[5px] min-w-[120px];
}
.favourite-no-animation {
  @apply absolute top-[5px] right-[5px] h-[32px] w-[32px] z-20 rounded-md bg-[rgba(242,116,139,0.2)] items-center justify-center flex;
}
.favourite-animation {
  @apply absolute top-[5px] right-[5px] h-[32px] w-[32px] z-20 rounded-md;
}
@keyframes fadeInFromBottom {
  0% {
    opacity: 0;
    transform: translateY(100%);
  }
  100% {
    opacity: 1;
    transform: translateY(0);
  }
}
@keyframes fadeInFromTop {
  0% {
    opacity: 0;
    transform: translateY(-100%);
  }
  100% {
    opacity: 1;
    transform: translateY(0);
  }
}
@keyframes fadeOutToTop {
  0% {
    opacity: 0;
    transform: translateY(0);
  }
  100% {
    opacity: 1;
    transform: translateY(-120%);
  }
}
@keyframes scaleAnimation {
  0% {
    transform: scale(1);
  }
  50% {
    transform: scale(1.5);
  }
  100% {
    transform: scale(1);
  }
}
@keyframes fadeColor {
  0% {
    background: rgba(242, 116, 139, 1);
  }
  50% {
    background: rgba(242, 116, 139, 1);
  }
  100% {
    background: rgba(242, 116, 139, 0.2);
  }
}
.group:hover .play__now__content_for_animate {
  animation: fadeInFromBottom .5s ease-in-out;
}
.group:hover .favourite-animation {
  @apply opacity-100;
}
.colorFade {
  animation: fadeColor 2s ease-in-out forwards;
}
.scale-animation {
  animation-iteration-count: 1;
  animation: scaleAnimation 1s normal forwards ease-in-out;
}
</style>
<style>
.el-popper.is-light.game-name span {
  color: #5f5f5f;
}
.el-popper.is-light.game-name .el-popper__arrow::before {
  background: #fff;
}
</style>
